
if !isdefined(Main, :Groebner)
    import Groebner
end

import AbstractAlgebra
using BenchmarkTools
using Logging
global_logger(ConsoleLogger(stderr, Logging.Error))

BenchmarkTools.DEFAULT_PARAMETERS.seconds = 100000


function benchmark_system_my(system)
    system = Groebner.change_ordering(system, :degrevlex)
    # Groebner.groebner([system[1]])

    # gb = Groebner.groebner(system)
    # println("length = $(length(gb))")
    # println("degree = $(maximum(AbstractAlgebra.total_degree, gb))")

    # bench = @benchmarkable Groebner.groebner($system, reduced=false) samples=5
    # println(median(run(bench)))

    gb = Groebner.groebner(system, reduced=false)

end

function run_f4_ff_degrevlex_benchmarks(ground)
    systems = [
        ("katsura 9", Groebner.katsura9(ground=ground)),
        ("eco 10"    ,Groebner.eco10(ground=ground)),
        ("noon 7"    ,Groebner.noonn(7, ground=ground)),
        ("cyclic 12", Groebner.rootn(12, ground=ground)),
    ]

    for (name, system) in systems
        println("$name")
        benchmark_system_my(system)
    end
end

ground = AbstractAlgebra.GF(2^31 - 1)
run_f4_ff_degrevlex_benchmarks(ground)

#=
cyclic 12
76.131 ms (180064 allocations: 28.05 MiB)
cyclic 13
224.358 ms (451559 allocations: 69.72 MiB)
katsura 9
332.042 ms (56380 allocations: 19.09 MiB)
noon 6
36.532 ms (88294 allocations: 21.21 MiB)
noon 7
279.662 ms (422861 allocations: 94.73 MiB)
=#
